{$I switches.inc}
unit VPA4;

interface

uses Graph, VPAData, AuxF;

procedure SetTaxes (nat:boolean; var tax:int);                  { M.O.T. }
procedure WriteMiningRate;
procedure WriteMineral (M,y:int; N,Nc:long; Nm:int);
procedure WriteActivity (var ep:epln);
procedure WriteTaxes (tax,y:int);
procedure WriteIncome(id:int);
function MouseGetTarget (lcolor,lstyle:byte; ctrl:boolean) : boolean;   { sets mmx,mmy }
function NearestObject (var mx,my:int) : word;  { sets new mx,my }

implementation

uses Screen, Mouse, StrF, Keyboard, VPA2;

procedure WriteMiningRate;
  var   s               : string[3];
        c               : byte;
        b               : boolean;
  begin
    if lplan=nil then Exit;
    c := IIF((lplan^.when=turn) and (lplan^.when=lplan^.when0),cPInfo,cOPInfo);
    with lplan^ do
    begin
      if (Nc<>-1) and (Nm<>-1) and (Nc<>0) then
      begin
        Clear(MX0+12*8+1,308,MX0+15*8-1,315);
        Str(MiningRate(lplan,Nc,Nm,@b):3,s);
        SetColor(IIF(b, Yellow, c));
        OutTextXY(MX0+12*8,308,s);
      end;
      if (Tc<>-1) and (Tm<>-1) and (Tc<>0) then
      begin
        Clear(MX0+12*8+1,318,MX0+15*8-1,325);
        Str(MiningRate(lplan,Tc,Tm,@b):3,s);
        SetColor(IIF(b, Yellow, c));
        OutTextXY(MX0+12*8,318,s);
      end;
      if (Dc<>-1) and (Dm<>-1) and (Dc<>0) then
      begin
        Clear(MX0+12*8+1,328,MX0+15*8-1,335);
        Str(MiningRate(lplan,Dc,Dm,@b):3,s);
        SetColor(IIF(b, Yellow, c));
        OutTextXY(MX0+12*8,328,s);
      end;
      if (Mc<>-1) and (Mm<>-1) and (Mc<>0) then
      begin
        Clear(MX0+12*8+1,338,MX0+15*8-1,345);
        Str(MiningRate(lplan,Mc,Mm,@b):3,s);
        SetColor(IIF(b, Yellow, c));
        OutTextXY(MX0+12*8,338,s);
      end;
    end;
    SetColor(c);
  end;

procedure WriteMineral (M,y:int; N,Nc:long; Nm:int);
  var   s,s1,s2,s3      : string[6];
        sm              : array [1..2] of char absolute M;
        b               : boolean;
        oc              : byte;
  begin
    s:=''; s1:='     '; s2:='';
    oc := GetColor;
    if N>-1 then Str(N:5,s);
    if (Nc<>-1) and (Nc<>-2) then Str(Nc:5,s1);
    OutTextXY(MX0,y,sm+s+s1);
    if (Nm<>-1) and (Nc<>0) then
    begin
      Str(MiningRate(lplan,Nc,Nm,@b):3,s3);
      if b then SetColor(yellow);
      s2:=s3+'/'+NStrMax(Nm,2,'+');
    end;
    OutTextXY(MX0+8*12,y,s2);
    SetColor(oc);
  end;

procedure WriteActivity (var ep:epln);
  var   k       : byte;
  begin
    k:=ep.activity and 7;
    if k=0 then Exit;
    if k>5 then k:=0;
    SetColor(IIF(ep.when=turn,cPInfo,cOPInfo));
    OutTextXY(MX0,224,Industry[k]);
    OutTextXY(MX0,232,'    industrial');
    OutTextXY(MX0,240,'          activity');
  end;

procedure WriteIncome(id:int);
  var   l       : long;
  begin
    Clear(MX0+10*8,272,638,279);
    l:=PlanetIncome(lplan,id);
    if l>0 then
    begin
      SetColor(IIF((lplan^.when=turn) and (lplan^.when=lplan^.when0),cPInfo,cOPInfo));
      OutTextXY(MX0,272,'Income  : '+NStr0(l));
    end;
  end;

procedure WriteTaxes (tax,y:int);
  var   s       : string[7];
  begin
    if tax=0 then s:='No' else s:=NStr(tax)+'%';
    OutTextXY(MX0,y,' Taxes: '+s);
  end;

procedure SetTaxes (nat:boolean; var tax:int);                  { M.O.T. }
  var   x,y,tax0  : int;
        number  : int;
        ch      : word;
        l       : int;
        s       : string[3];
  begin
    if (lplan=nil) or (lplan^.when<>today) or (nat and (lplan^.Nrace=0)) then Exit;
    {MouseOff;}
    MouseDisabled:=True;
    l:=0; if nat and not ShowMaxPop then l:=8;
    SetLineStyle(SolidLn,0,NormWidth);
    x:=MX0+8*8;
    y:=IIF(nat,160,200);
    Clear(MX0+11*8,y+l,639,y+7+l);
    tax0:=tax;
    number:=lock and LockLo;
    repeat
      WriteHChange(nat);
      WriteMaxPop(-1,0);
      Clear(MX0+8*8,y+l,MX0+12*8-1,y+7+l);
      WriteTaxes(tax,y+l);
      repeat ArrowBlink(624,y+l) until KeyPressed;
      ch:=ReadKey;
      case ch of
        $4B00   : if tax>0 then
                  begin
                    if KbdFlags and KbdShft=0 then dec(tax) else tax:=0;
                    WriteIncome(number);
                  end;
        $4D00   : if tax<100 then
                  begin
                    if KbdFlags and KbdShft=0 then inc(tax) else tax:=100;
                    WriteIncome(number);
                  end;
        $7300   : if tax>=10 then
                  begin
                    dec(tax,10);
                    WriteIncome(number);
                  end;
        $7400   : if tax<=90 then
                  begin
                    inc(tax,10);
                    WriteIncome(number);
                  end;
        ord('0')..ord('9') :
                  begin
                    GetStr1stKey:=ch;
                    s:=GetStr(x,y+l,3);
                    if GetStrKey=13 then
                    begin
                      tax := Value(s);
                      if tax<0 then tax:=0;
                      if tax>100 then tax:=100;
                      WriteIncome(number);
                    end;
                  end;
        $3B00   : begin
                    helpscr:=5;
                    Help;
                    helpscr:=0;
                    DrawMap(Yes);
                  end;
      end;
    until (ch=13) or (ch=27);
    {if ch=27 then tax:=tax0;}
    if tax<>tax0 then ChangeData(Pl,lock and LockLo);
    Clear(MX0+8*8,y+l,639,y+7+l);
    WriteHChange(nat);
    WriteTaxes(tax,y+l);
    SetColor(White);
    if nat then OutTextXY(MX0+8,160+l,'T')
           else OutTextXY(MX0+24,200+l,'x');
    WriteIncome(number);
    MouseDisabled:=False;
    {MouseOn;}
  end;

function MouseGetTarget (lcolor,lstyle:byte; ctrl:boolean) : boolean;   { sets mmx,mmy }
  var   ch,mEv0 : word;
        mdis0   : boolean;
        lock0,glx0,gly0,lx0,ly0 : int;
        x0,y0,x1,y1             : int;
        ack     : word;
  procedure DrawLine;
    begin
      if lcolor=0 then Exit;
      MouseOff;
      SetWriteMode(XORPut);
      SetColor(lcolor);
      Line(x0,y0,x1,y1);
      SetWriteMode(NormalPut);
      MouseOn;
    end;
  procedure NewPoint;
    begin
      DrawLine;
      WriteCoord;
      x1:=MouseX; y1:=MouseY;
      DrawLine;
    end;
  procedure LockObj;
    var mx,my   : int;
    begin
      lx:=mmx; ly:=mmy;
      lock:=NearestObject(lx,ly);
      Abs2Scr(lx,ly,mx,my);
      MoveMouseTo(mx,my);
    end;
  begin
    ack:=IIF(ctrl,10,13);
    lock0:=lock; lock:=0;
    lx0:=lx; lx:=0;
    ly0:=ly; ly:=0;
    glx0:=glx; glx:=0;
    gly0:=gly; gly:=0;
    mdis0:=MouseDisabled;
    MouseDisabled:=No;
    Abs2Scr(mmx,mmy,x0,y0);
    SetLineStyle(lstyle,0,NormWidth);
    x1:=x0; y1:=y0;
    ch:=0;
    DrawLine;
    repeat
      if KeyPressed then
      begin
        ch:=ReadKey;
        case ch of
{left}    $4B00 : if MouseX>0   then MoveMouseTo(MouseX-Max(1,ratio2 div ratio1),MouseY);
{right}   $4D00 : if MouseX<479 then MoveMouseTo(MouseX+Max(1,ratio2 div ratio1),MouseY);
{up}      $4800 : if MouseY>0   then MoveMouseTo(MouseX,MouseY-Max(1,ratio2 div ratio1));
{down}    $5000 : if MouseY<479 then MoveMouseTo(MouseX,MouseY+Max(1,ratio2 div ratio1));
{~lt}     $9B00 : if MouseX>9   then MoveMouseTo(MouseX-10,MouseY);
{~rt}     $9D00 : if MouseX<470 then MoveMouseTo(MouseX+10,MouseY);
{~up}     $9800 : if MouseY>9   then MoveMouseTo(MouseX,MouseY-10);
{~dn}     $A000 : if MouseY<470 then MoveMouseTo(MouseX,MouseY+10);
          13    : begin LockObj; if ctrl then NewPoint end;
        end;
        NewPoint;
        if (ch<>13) and (ch<>ack) then lock:=0;
      end;
      if mEvent<>0 then
      begin
        mEv0:=mEvent; mEvent:=0;
        if mEv0=EvMouseMove then begin NewPoint; lock:=0 end;
        if mEv0=EvLtPress then
          if (not ctrl) or (KbdFlags and KbdCtrl<>0) then ch:=ack
          else begin LockObj; NewPoint end;
        if mEv0=EvRtPress then ch:=27;
        mEv0:=0;
      end;
    until (ch=ack) or (ch=27);
    DrawLine;
    MouseDisabled:=mdis0;
    lock:=lock0;
    lx:=lx0; ly:=ly0;
    glx:=glx0; gly:=gly0;
    MouseGetTarget:=(ch=ack);
  end;

function NearestObject (var mx,my:int) : word;  { sets new mx,my }
  var   shift   : boolean;
        i,n     : int;
        nd,dd   : long;
        nx,ny   : int;
        lck     : int;
  procedure Check (x,y:int);
    begin
      if x=-1 then Exit;
      dd:=Distance2(mx,my,x,y);
      if dd<nd then
      begin
        nd:=dd;
        nx:=x; ny:=y;
        n:=i or lck;
      end;
    end;
  begin
    shift:=(showM or showI or showU or showA) and ((KbdFlags and KbdShft)<>0);
    n:=0;
    nd:=1000000000;
    with TTurn^.data^ do
    begin
      if not shift then
      begin
        lck:=LockP;
        for i:=1 to 500 do Check(xyplan[i,1],xyplan[i,2]);
        lck:=LockS;
        if showS or showE then
          for i:=1 to 999 do
            with ship[i]^ do
            if (ship[i]<>nil) and (when=turn) and (splan[i]=0) and
               ((showS and (owner=player)) or (showE and (owner<>player))) then
              Check(x,y);
        if distlock<0 then
        begin
          lck:=0; i:=distlock;
          Check(dlx,dly);
        end;
      end;
      lck:=LockM;
      if showM then
        for i:=1 to 500 do
          with mines[i]^ do
          if mines[i]<>nil then Check(x,y);
      lck:=LockI;
      if showI then
        for i:=1 to 50 do
          with ion[i]^ do
          if ion[i]<>nil then Check(x,y);
      lck:=LockW;
      if showU then
        for i:=0 to 199 do
          with worm[i]^ do
          if worm[i]<>nil then Check(x,y);
      lck:=LockU;
      if showU then
        for i:=1 to 100 do
          with ufo[i]^ do
          if ufo[i]<>nil then Check(x,y);
      lck:=LockA;
      if showA then
        for i:=1 to nmark do
          with mark^[i] do
          if (mtype<>mrkNone) and ((not shift) or (mtype=mrkRCircle)) then
          begin
            Check(x,y);
            if (mtype in [mrkLine,mrkDLine]) then Check(x+dx,y+dy);
          end;
    end;
    NearestObject:=n;
    if n<>0 then begin mx:=nx; my:=ny end;
  end;

end.

